#include<bits/stdc++.h>
using namespace std;
const int L=20;
int n,q;
int head[500005],cnt;
int fa[500005][21],dep[500005];
struct edge
{
	int nxt,to;
}e[1050000];
void link(int x,int y)
{
	cnt++;
	e[cnt].nxt=head[x];
	e[cnt].to=y;
	head[x]=cnt;
}
void dfs(int x,int rt)
{
	fa[x][0]=rt;
	dep[x]=dep[rt]+1;
	for(int i=1;i<=L;i++)
	{
		fa[x][i]=fa[fa[x][i-1]][i-1];
	}
	for(int i=head[x];i;i=e[i].nxt)
	{
		int v=e[i].to;
		if(v==rt)continue;
		dfs(v,x);
	}
}
//int glca(int x,int y)
//{
//	if(dep[x]>dep[y])swap(x,y);
//	for(int i=L;i>=0;i--)
//	{
//		if(dep[x]>dep[y])x=fa[x][i];
//	}
//	if(x==y)return x;
//	for(int i=L;i>=0;i--)
//	{
//		if(dep[x]!=dep[y])x=fa[x][i],y=fa[y][i];
//	}
//	return fa[x][0];
//}
int glca(int x,int y)
{
	if(dep[x]<dep[y])swap(x,y);
	for(int i=L;i>=0;i--)
	{
		while(dep[fa[x][i]]>dep[y])x=fa[x][i];
	}
//	if(x==y)return x;
	while(dep[x]>dep[y])x=fa[x][0];
	while(x!=y)x=fa[x][0],y=fa[y][0];
	return x;
}
int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	for(int i=1;i<n;i++)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		link(x,y);
		link(y,x);
	}
	dfs(1,0);
	scanf("%d",&q);
	while(q--)
	{
		int l,r,k,ans=0;
		scanf("%d%d%d",&l,&r,&k);
		for(int i=l;i<=r-k+1;i++)
		{
			int p=i;
			for(int j=i+1;j<=i+k-1;j++)
			{
				p=glca(p,j);
			}
			ans=max(ans,dep[p]);
		}
		printf("%d\n",ans);
	}
	return 0;
 } 
